// The Tower of Gazzel (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x200*9*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;
	unsigned char id1[] = "Gzel_No";
	unsigned char id2[] = "Gzel_UD";

	// Disk 1 (Demo Disk 1)
	struct fpos md1[] =
	{
		{ 0x4b, 0x03, 0x0200 }, // SE #1
		{ 0x4b, 0x04, 0x0200 }, // SE #2
		{ 0x4a, 0x09, 0x0c00 }, // I[vjO1
		{ 0x4a, 0x03, 0x0c00 }, // I[vjO2(C^Cg)
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};
	struct fpos vd1[] =
	{
		{ 0x4b, 0x05, 0x0400 }, // 
		{ 0x4b, 0x07, 0x0400 }, // 
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	// Disk 2 (Demo Disk 2)
	struct fpos md2[] =
	{
		{ 0x37, 0x06, 0x0400 }, // Lr^CY/I[vjO
		{ 0x37, 0x08, 0x0600 }, // Lr^CY/CBGM
		{ 0x38, 0x06, 0x0800 }, // Lr^CY/d]GW
		{ 0x38, 0x02, 0x0800 }, // Lr^CY/CABIN CM
		{ 0x38, 0x08, 0x0800 }, // Lr^CY/GfBO
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	// Disk 3 (Demo Disk 3)
	struct fpos md3[] =
	{
		{ 0x4b, 0x06, 0x0800 }, // A
		{ 0x4c, 0x02, 0x0200 }, // j(ʑ)
		{ 0x4c, 0x03, 0x0200 }, // j(ʏ)
		{ 0x4c, 0x04, 0x0800 }, // X^bt[
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	struct fpos vd2[] =
	{
		{ 0x36, 0x09, 0x0400 }, // 
		{ 0x37, 0x02, 0x0400 }, // 
		{ 0x37, 0x04, 0x0400 }, // 
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	// Disk 4
	struct fpos md4[] =
	{
		{ 0x38, 0x07, 0x0800 }, // {[Y̐X
		{ 0x37, 0x04, 0x0a00 }, // ̓
		{ 0x35, 0x04, 0x0600 }, // ñtA
		{ 0x34, 0x09, 0x0400 }, // n
		{ 0x35, 0x09, 0x0800 }, // ̃tA
		{ 0x39, 0x04, 0x0800 }, // 
		{ 0x3a, 0x02, 0x0600 }, // {XΖ
		{ 0x3a, 0x05, 0x0800 }, // @
		{ 0x37, 0x08, 0x0200 }, // GAME OVER
		{ 0x37, 0x09, 0x0200 }, // BOSS OUT
		{ 0x3a, 0x01, 0x0200 }, // BOSS #1
		{ 0x38, 0x04, 0x0200 }, // SE (T_[{g)
		{ 0x3c, 0x07, 0x0400 }, // AXp̉
		{ 0x36, 0x04, 0x0600 }, // ̃tA
		{ 0x3b, 0x07, 0x0800 }, // BOSS #2(Jj)
		{ 0x38, 0x05, 0x0400 }, // l̓J
		{ 0x3c, 0x06, 0x0200 }, // O
		{ 0x36, 0x09, 0x0800 }, // ̃tA
		{ 0x3a, 0x09, 0x0800 }, // AEAN
		{ 0x3b, 0x04, 0x0600 }, // hS
		{ 0x3c, 0x02, 0x0800 }, // MEx[X
		{ 0x38, 0x03, 0x0200 }, // K[f
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	struct fpos vd4[] =
	{
		{ 0x35, 0x02, 0x0400 }, // 
		{ 0x35, 0x07, 0x0400 }, // 
		{ 0x36, 0x07, 0x0400 }, // 
		{ 0x38, 0x01, 0x0400 }, // 
		{ 0x39, 0x02, 0x0400 }, // 
		{ 0x39, 0x08, 0x0400 }, // 
		{ 0x3c, 0x09, 0x0400 }, // 
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	// Disk 6
	struct fpos md6[] =
	{
		{ 0x47, 0x08, 0x0600 }, // ṼtA
		{ 0x49, 0x03, 0x0800 }, // pEG̗
		{ 0x48, 0x07, 0x0600 }, // ł̃tA
		{ 0x49, 0x07, 0x0600 }, // [OCA̒R
		{ 0x4a, 0x01, 0x0600 }, // `t]
		{ 0x4a, 0x06, 0x0800 }, // K[
		{ 0x48, 0x04, 0x0200 }, // j(ʑ)
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	struct fpos vd6[] =
	{
		{ 0x48, 0x05, 0x0400 }, // 
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x09);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x02, buff, 0x200);
		if (!memcmp(&buff[0x03],id1,sizeof(id1)-1))
		{
			switch(buff[0x0a])
			{
				case '1':
					printf("Disk 1 (Demo Disk 1)F܂.\n");
					fcut("MMD.COM",  0x08, 0x04, 0x00, 0x06, 0x02, 0x0000, 0x0a5c);
					for (i=0; md1[i].sec; i++)
					{
						sprintf(fname,"MUS1%02d",i);
						fcut(fname, md1[i].trk, md1[i].trk>>1, md1[i].trk&1, md1[i].sec, 0x02, 0x0000, md1[i].size);
					}
					for (i=0; vd1[i].sec; i++)
					{
						sprintf(fname,"VD1%02d",i);
						fcut(fname, vd1[i].trk, vd1[i].trk>>1, vd1[i].trk&1, vd1[i].sec, 0x02, 0x0000, vd1[i].size);
					}
					break;
				case '2':
					printf("Disk 2 (Demo Disk 2)F܂.\n");
					for (i=0; md2[i].sec; i++)
					{
						sprintf(fname,"MUS2%02d",i);
						fcut(fname, md2[i].trk, md2[i].trk>>1, md2[i].trk&1, md2[i].sec, 0x02, 0x0000, md2[i].size);
					}
					for (i=0; vd2[i].sec; i++)
					{
						sprintf(fname,"VD2%02d",i);
						fcut(fname, vd2[i].trk, vd2[i].trk>>1, vd2[i].trk&1, vd2[i].sec, 0x02, 0x0000, vd2[i].size);
					}
					break;
				case '3':
					printf("Disk 3 (Demo Disk 3)F܂.\n");
					for (i=0; md3[i].sec; i++)
					{
						sprintf(fname,"MUS3%02d",i);
						fcut(fname, md3[i].trk, md3[i].trk>>1, md3[i].trk&1, md3[i].sec, 0x02, 0x0000, md3[i].size);
					}
					break;
				case '4':
					printf("Disk 4 (Program Disk)F܂.\n");
					for (i=0; md4[i].sec; i++)
					{
						sprintf(fname,"MUS4%02d",i);
						fcut(fname, md4[i].trk, md4[i].trk>>1, md4[i].trk&1, md4[i].sec, 0x02, 0x0000, md4[i].size);
					}
					for (i=0; vd4[i].sec; i++)
					{
						sprintf(fname,"VD4%02d",i);
						fcut(fname, vd4[i].trk, vd4[i].trk>>1, vd4[i].trk&1, vd4[i].sec, 0x02, 0x0000, vd4[i].size);
					}
					break;
				case '5':
					printf("Disk 5 F܂.\n");
					break;
				case '6':
					printf("Disk 6 F܂.\n");
					for (i=0; md6[i].sec; i++)
					{
						sprintf(fname,"MUS6%02d",i);
						fcut(fname, md6[i].trk, md6[i].trk>>1, md6[i].trk&1, md6[i].sec, 0x02, 0x0000, md6[i].size);
					}
					for (i=0; vd6[i].sec; i++)
					{
						sprintf(fname,"VD6%02d",i);
						fcut(fname, vd6[i].trk, vd6[i].trk>>1, vd6[i].trk&1, vd6[i].sec, 0x02, 0x0000, vd6[i].size);
					}
					break;
			}
			continue;
		}
		else if (!memcmp(&buff[0x03],id2,sizeof(id2)-1))
		{
			printf("User DiskF܂.\n");
			continue;
		}
		printf("FłȂfBXNł.\n");
	}
	return 0;
}

